/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

(function($) {
     $.api = function( opciones_user, datos){
        var opciones = $.extend( $.api.op_default , opciones_user);
        var  datosActividades = $.extend(  $.api.datosActividades , datos);
        for(var obj in datosActividades){
            construyeActividad(obj,datosActividades[obj].tipo);
        }
        verificarContestados();

        //$.api.preloadImages(opciones.ruta_imagen_bien,opciones.ruta_imagen_mal);
        setTimeout($.api.revisaTamano,7000);

        // ----------- ASIGNAR ESTILOS -------------------
            //$.api.style.instrucciones = {};
            //$.api.style.pregunta = {};
            //$.api.style.respuesta = {};
        $(".instrucciones").css($.api.style.instrucciones);
        $(".pregunta").css($.api.style.pregunta);
        $(".respuesta").css($.api.style.respuesta);


        /**
         *
         * Funcion que cambia los ID's de la pregunta, el boton
         * y el campo de retroalimentacion de cada una de las preguntas ("jspregunta")
         * de la actividad que se pasa como argumento (idActividad).
         *
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad El atributo ID de la actividad a modificar.
         * @param tipo El tipo de actividad a construir.
         *
         * */
        function construyeActividad(idActividad,tipo){

            $("#"+idActividad).css($.api.style.actividad);//Estilos para la actividad

            datosActividades[idActividad].total=$("[title='jspregunta']",$("#"+idActividad)).length;//Marco el total de actividades.

            $("[title='jspregunta']",$("#"+idActividad)).each(function(i){//Por cada pregunta..
                var pregunta = $(this);
                pregunta.attr("id", idActividad+"__pregunta"+i);//Asigno ID especifico
                if($("[alt='revisar']",pregunta).length==0){
                    pregunta.append('<span style="cursor:pointer;" ><img alt="revisar" src="'+opciones.ruta_imagen_revisar+'"/></span>');
                }else{
                    $("[alt='revisar']",pregunta).replaceWith('<span style="cursor:pointer;" ><img alt="revisar" src="'+opciones.ruta_imagen_revisar+'"/></span>');
                }
                $("[alt='revisar']",pregunta).attr("id", idActividad+"__boton"+i)//Modifico boton de la pregunta

                if($("[title='retroalimentacion']",pregunta).length==0){
                    pregunta.append('<span title="retroalimentacion"></span>');
                }

                $("[title='retroalimentacion']",pregunta).attr("id", idActividad+"__retro"+i);//Marcar la retroalimentacion.

                construyeRespuesta(idActividad,tipo,i);//Construye las posibles respuestas.


                
                
                var obj = $.parseJSON('{"'+idActividad+"__pregunta"+i+'":false}');
                datosActividades[idActividad].porContestar.push(obj);//Agregamos el ide de la pregunta para poder saber cuando ya contesto todas las preguntas de una actividad.
		pregunta.removeAttr("title");
            });



        }

        /**
         * Funcion que dependiendo del tipo de actividad, manda a construir la pregunta.
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a modificar
         * @param tipo El tipo de ejercicio.
         * @param posicion La posición o numero de pregunta de la actividad.
         */
        function construyeRespuesta(idActividad,tipo,posicion){
            switch(tipo){
                case "textarea":
                    construyeTextArea(idActividad,posicion);
                    break;
                case "select":
                    construyeSelect(idActividad,posicion);
                    break;
                case "text":
                    construyeText(idActividad,posicion);
                    break;
                case "radiobutton":
                    construyeRadiobutton(idActividad,posicion);
                    break;
                case "checkbox":
                    contruyeCheckbox(idActividad,posicion);
                    break;
            }
        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo checkbox.
         *
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function contruyeCheckbox(idActividad,posicion){

            /* ----- Colocar nombres, id y espacios para retroalimentacion visual. --- */
            $("input:checkbox",$("#"+idActividad+"__pregunta"+posicion)).each(function(i){
                $(this).attr("name", idActividad+"__respuesta"+posicion+"__"+i);
                $(this).attr("id", idActividad+"__respuesta"+posicion+"__"+i);

                $(this).val(datosActividades[idActividad].respuestas[posicion][i]);// El atributo value, tiene la respuesta correcta (true o false).
                $("#"+idActividad+"__pregunta"+posicion).append('<div class="visual" style="position:absolute; left: 0px;  top: 0px;" id="'+idActividad+"__visual"+posicion+'__'+i+'"></div>');
                $("#"+idActividad+"__visual"+posicion+"__"+i).offset($(this).offset());
            });

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                evaluaCheckbox(this.id.toString(),true);
                return false;
            });

        }

        function evaluaCheckbox(sboton,guardar){
            // ------- Obtener idActividad y numero de pregunta -------------
            var datosR = sboton.split("__boton");
            if(datosR.length<2)return;
            var idActividad = datosR[0];
            var nPregunta = datosR[1];
            var datosAct = datosActividades[idActividad];



            // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
            var hayText = true;//bandera para terminar el for
            var i=correctas=0;//indice y contador de correctas
            var datos = "";
            for(i=0;hayText;i++){
                var respuesta = $("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']");//Obtengo el checkbox i
                $("#"+idActividad+"__visual"+nPregunta+"__"+i).html("");
                if(respuesta.length>0){//Si existe
                    var offsetin = respuesta.offset();
                    offsetin.left = offsetin.left-12;
                    $("#"+idActividad+"__visual"+nPregunta+"__"+i).offset(offsetin);
                    //$("#"+idActividad+"__visual"+nPregunta+"__"+i).offset(respuesta.offset());//Posicionamos la palomita.
                    if(respuesta.attr("checked")){
                        datos += idActividad+"__respuesta"+nPregunta+"__"+i+"=true&";
                    }else{
                        if(""+respuesta.attr("checked")==respuesta.val())
                            correctas++;
                        continue;
                    }
                    /*if(""+respuesta.attr("checked")==respuesta.val()){//Si el atreibuto checked es igual al valor del checked, es correcta.
                        if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                            $("#"+idActividad+"__visual"+nPregunta+"__"+i).html('<img src="'+opciones.ruta_imagen_bien+'"/>');
                        correctas++;
                    }else{
                        if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                            $("#"+idActividad+"__visual"+nPregunta+"__"+i).html('<img src="'+opciones.ruta_imagen_mal+'"/>');
                    }*/
                }else{
                    hayText = false;
                    i--;
                }

            }

            // ---------- Obtengo el porcentaje obtenido de correctas --------------
            var porcentaje=0;
            if(i>0)
                porcentaje = correctas*100/i;

            // ---------- Muestro la retroalimentacion textual  ---------
            if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                var mensajes = obtenerMensaje(idActividad,nPregunta);
                muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
            }
            
            if(guardar)
                guardarEjercicio(idActividad,nPregunta,"checkbox",datos,porcentaje);

        }

        /**
         * Obtiene el los mensajes de la retroalimentación textual de una pregunta específica.
         *
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad de la cual se obtendran los mensajes.
         * @param nPregunta El numero de pregunta para que obtenga los mensajes especificos si existen.
         * @retuen Array El arreglo de respuestas.
         **/
        function obtenerMensaje(idActividad,nPregunta){
            if(datosActividades[idActividad].mensajes[nPregunta]!=undefined){
                return datosActividades[idActividad].mensajes[nPregunta];
            }else{
                return datosActividades[idActividad].mensajes[0];
            }
        }

        /**
         * Muestra un mensaje especifico dependiendo del porcentaje obtenido dentro de
         * el elemento donde se mostrará la retroalimentación textual de la pregunta.
         *
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param elementoJQ El elemento JQuery donde cargará la retroalimentación.
         * @param porcentaje El porcentaje obtenido al evaluar la pregunta.
         * @param mensajes Array con los diferentes mensajes a mostrar.
         **/
        function muestraMesnaje(elmentoJQ,porcentaje,mensajes){
            elmentoJQ.removeAttr("class").removeAttr("style").attr("style","font-family: Arial, Helvetica, sans-serif;font-style:oblique;font-weight:bold;font-size:12px;");
            var div = null;
            var bien = false;

            var styleBien = "";
            for(var str in $.api.style.bien){
                styleBien += str+":"+$.api.style.bien[str]+";";
            }
            var styleMal = "";
            for(var str in $.api.style.mal){
                styleMal += str+":"+$.api.style.mal[str]+";";
            }

            var imagen = "";
            
            //elmentoJQ.addClass("caja_revisar_incisos");
            if(typeof mensajes[0] != "string"){//Si no es string quiere decir que mostrará la retroalimentación dependiendo de el porcentaje obtenido
                $.each(mensajes,function(m){
                    if(porcentaje<=this[0]){
                        if(porcentaje>60){
                            if(opciones.ruta_imagen_retro_bien.length>0)
                                imagen = '<img src="'+opciones.ruta_imagen_retro_bien+'"/>';
                            elmentoJQ.html('<div style="'+styleBien+'">'+this[1]+"</div>");
                            bien = true;
                        }else{
                            if(opciones.ruta_imagen_retro_mal.length>0)
                                imagen = '<img src="'+opciones.ruta_imagen_retro_mal+'"/>';
                            elmentoJQ.html('<div style="'+styleMal+'">'+this[1]+"</div>");
                        }
                        return false;
                    }
                });
            }else{// Si el mensaje es una cadena, quiere decir que mostrará la retroalimentación en base a "bien(100%)" o "mal(menos del 100%)".
                if(typeof mensajes[1]=="undefined"){
                    if(opciones.ruta_imagen_retro_bien.length>0)
                                imagen = '<img src="'+opciones.ruta_imagen_retro_bien+'"/>';
                    elmentoJQ.html('<div style="'+styleBien+'">'+mensajes[0]+"</div>");
                    bien = true;
                }else if(porcentaje>99){
                    if(opciones.ruta_imagen_retro_bien.length>0)
                                imagen = '<img src="'+opciones.ruta_imagen_retro_bien+'"/>';
                    elmentoJQ.html('<div style="'+styleBien+'">'+mensajes[1]+"</div>");
                    bien = true;
                }else{
                    if(opciones.ruta_imagen_retro_mal.length>0)
                                imagen = '<img src="'+opciones.ruta_imagen_retro_mal+'"/>';
                    elmentoJQ.html('<div style="'+styleMal+'">'+mensajes[0]+"</div>");
                }
            }

            if(true){ //Se cambio el argumento de bien a true para que la retroalimentación negativa no desaparezca
                $("div",elmentoJQ).fadeIn(800);
            }else{
                $("div",elmentoJQ).fadeIn(500,function(){setTimeout(function(){$("div",elmentoJQ).fadeOut(1000);},1000);});
            }

        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo text.
         *
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function construyeText(idActividad,posicion){

            /* ----- Colocar nombres, id y espacios para retroalimentacion visual. --- */
            $("input:text",$("#"+idActividad+"__pregunta"+posicion)).each(function(i){
                $(this).attr("name", idActividad+"__respuesta"+posicion+"__"+i);
                $(this).attr("id", idActividad+"__respuesta"+posicion+"__"+i);

                $("#"+idActividad+"__pregunta"+posicion).append('<div class="visual" style="position:absolute; left: 0px;  top: 0px;" id="'+idActividad+"__visual"+posicion+'__'+i+'"></div>');
                $("#"+idActividad+"__visual"+posicion+"__"+i).offset($(this).offset());
            });

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                evaluaText(this.id.toString(),true);
                return false;
            });
        }

        function evaluaText(sboton,guardar){
            // ------- Obtener idActividad y numero de pregunta -------------
            var datosR = sboton.split("__boton");
            if(datosR.length<2)return;
            var idActividad = datosR[0];
            var nPregunta = datosR[1];
            var datosAct = datosActividades[idActividad];

            // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
            var respuestas = datosAct.respuestas[nPregunta];
            var hayText = true;//Bandera para terminar el for
            var correctas = 0;
            var i=0;
            var datos="";
            for(i=0;hayText;i++){
                if($("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']").length>0){
                    var offset = $("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']").offset();
                    offset.left = offset.left-12;
                    $("#"+idActividad+"__visual"+nPregunta+"__"+i).offset(offset);//Posicionamos la retroalimentacion visual
                    datos += idActividad+"__respuesta"+nPregunta+"__"+i+"="+$("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']").val()+"&"
                    if(respuestas[i]==$("input[name='"+idActividad+"__respuesta"+nPregunta+"__"+i+"']").val().toLowerCase()){
                        /*if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                            $("#"+idActividad+"__visual"+nPregunta+"__"+i).html('<img src="'+opciones.ruta_imagen_bien+'"/>');*/
                        correctas++;
                    }else{
                        /*if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                            $("#"+idActividad+"__visual"+nPregunta+"__"+i).html('<img src="'+opciones.ruta_imagen_mal+'"/>');*/
                    }
                }else{
                    hayText = false;
                }

            }
            i--;//Restarle uno para que sea el numero exacto de preguntas.

            // ---------- Obtengo el porcentaje obtenido de correctas --------------
            var porcentaje = correctas*100/i;

            // ---------- Muestro la retroalimentacion textual  ---------
            if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                var mensajes = obtenerMensaje(idActividad,nPregunta);
                muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
            }
            if(guardar)
                guardarEjercicio(idActividad,nPregunta,"text",datos,porcentaje);
        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo select.
         *
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function construyeSelect(idActividad,posicion){

            /* ----- Colocar nombres, id y espacios para retroalimentacion visual. --- */
            $("select",$("#"+idActividad+"__pregunta"+posicion)).attr("name", idActividad+"__respuesta"+posicion);
            $("select",$("#"+idActividad+"__pregunta"+posicion)).attr("id", idActividad+"__respuesta"+posicion);

            $("#"+idActividad+"__pregunta"+posicion).append('<div class="visual" style="position:absolute; left: 0px;  top: 0px;" id="'+idActividad+"__visual"+posicion+'"></div>');
            $("#"+idActividad+"__visual"+posicion).offset($("select",$("#"+idActividad+"__pregunta"+posicion)).offset());

            $("select option",$("#"+idActividad+"__pregunta"+posicion)).each(function(i){
                $(this).val(i);
            });

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                evaluaSelect(this.id.toString(),true);
                return false;
            });

        }

        function evaluaSelect(sboton,guarda){
            // ------- Obtener idActividad y numero de pregunta -------------
            var datosR = sboton.split("__boton");
            if(datosR.length<2)return;
            var idActividad = datosR[0];
            var nPregunta = datosR[1];
            var datosAct = datosActividades[idActividad];

            var offset = $("select[name='"+idActividad+"__respuesta"+nPregunta+"']").offset();
            offset.left = offset.left-12;
            $("#"+idActividad+"__visual"+nPregunta).offset(offset);//Posiciono la retroalimebtacion visual.

            // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
            var contesto = $("select[name='"+idActividad+"__respuesta"+nPregunta+"']").val();
            var correcta=contesto==datosActividades[idActividad].respuestas[nPregunta];

            /*if(correcta){
                if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                    $("#"+idActividad+"__visual"+nPregunta).html('<img src="'+opciones.ruta_imagen_bien+'"/>');
            }else{
                if(datosAct.rvisual)//Si puede mostrar retroalimentacion visual
                    $("#"+idActividad+"__visual"+nPregunta).html('<img src="'+opciones.ruta_imagen_mal+'"/>');
            }*/

            // ---------- Obtengo el porcentaje obtenido de correctas --------------
            var porcentaje = correcta?100:0;

            // ---------- Muestro la retroalimentacion textual  ---------
            if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                var mensajes = obtenerMensaje(idActividad,nPregunta);
                muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
            }
            if(guarda)
                guardarEjercicio(idActividad,nPregunta,"select",idActividad+"__respuesta"+nPregunta+"="+contesto,porcentaje);
        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo radio.
         *
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function construyeRadiobutton(idActividad,posicion){

            /* ----- Colocar nombres, id y espacios para retroalimentacion visual. --- */
            $("input:radio",$("#"+idActividad+"__pregunta"+posicion)).attr("name", idActividad+"__respuesta"+posicion);
            $("input:radio",$("#"+idActividad+"__pregunta"+posicion)).each(function(i){
                $(this).val(i);
                $(this).attr("id", idActividad+"__respuesta"+posicion+"_"+i);
                $("#"+idActividad+"__pregunta"+posicion).append('<div class="visual" style="position:absolute; left: 0px;  top: 0px;" id="'+idActividad+"__visual"+posicion+"_"+i+'"></div>');
            });

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                evaluaRadio(this.id.toString(),true);
                return false;
            });

        }

        function evaluaRadio(sboton,guarda){
            // ------- Obtener idActividad y numero de pregunta -------------
            var datosR = sboton.split("__boton");
            if(datosR.length<2)return;
            var idActividad = datosR[0];
            var nPregunta = datosR[1];
            var datosAct = datosActividades[idActividad];

            // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
            var correcta = $("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").val() == datosActividades[idActividad].respuestas[nPregunta];
            var nResp = $("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").attr("id").split("__respuesta"+nPregunta)[1];

             $(".visual",$("#"+idActividad+"__pregunta"+nPregunta)).html("");
            if(correcta){
                /*if(datosAct.rvisual){//Si puede mostrar retroalimentacion visual
                    $("#"+idActividad+"__visual"+nPregunta+nResp).html('<img src="'+opciones.ruta_imagen_bien+'"/>');
                }*/
            }else{
                if(datosAct.rvisual){//Si puede mostrar retroalimentacion visual
                    if($("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").val()==undefined){
                        alert("Debes seleccionar al menos una respuesta");
                        return;
                    }
                    //$("#"+idActividad+"__visual"+nPregunta+nResp).html('<img src="'+opciones.ruta_imagen_mal+'"/>');
                }
            }
            var offsetin = $("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").offset()
            offsetin.left = offsetin.left-12;
            $("#"+idActividad+"__visual"+nPregunta+nResp).offset(offsetin);

            // ---------- Obtengo el porcentaje obtenido de correctas --------------
            var porcentaje = correcta?100:0;

            // ---------- Muestro la retroalimentacion textual  ---------
            if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                var mensajes = obtenerMensaje(idActividad,nPregunta);
                muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
            }
            var datos = idActividad+"__respuesta"+nPregunta+"="+$("input[name='"+idActividad+"__respuesta"+nPregunta+"']:checked").val();
            if(guarda)
                guardarEjercicio(idActividad,nPregunta,"radio",datos,porcentaje);
         
        }

        /**
         * Asigna ID's, nombres, crea espacio para visualizar la retroalimentacion
         * visual posicionandolo y agrega funcionalidad al boton de cada una de las
         * preguntas de tipo textarea.
         *
         * @autor Juan Manuel Muñoz Perez  juan.manuel.mp8@gmail.com (MACUCO)
         * @param idActividad La actividad a construir.
         * @param posiscion El numero de pregunta a construir.
         **/
        function construyeTextArea(idActividad,posicion){

            /* ----- Colocar nombres e id ------ */
            $("textarea",$("#"+idActividad+"__pregunta"+posicion)).attr("name",idActividad+"__respuesta"+posicion);
            $("textarea",$("#"+idActividad+"__pregunta"+posicion)).attr("id",idActividad+"__respuesta"+posicion);
            $("textarea",$("#"+idActividad+"__pregunta"+posicion)).attr({"rows":5,"cols":50});
            

            /* ----- Evaluar la pregunta ------ */
            $("#"+idActividad+"__boton"+posicion).click(function(){
                evaluaTextarea(this.id.toString(),true);
                return false;
            });
        }

        function evaluaTextarea(sboton,guarda){

            // ------- Obtener idActividad y numero de pregunta -------------
            var datosR = sboton.split("__boton");
            if(datosR.length<2)return;
            var idActividad = datosR[0];
            var nPregunta = datosR[1];
            var datosAct = datosActividades[idActividad];

            // ------- Verifico cuales son correctas, incorrectas y cuento las correctas ---------
            prespuestas = datosAct.respuestas[nPregunta];
            var correctas = Array();
            for(var i=0;i<prespuestas.length;i++){
                correctas[i]=0;
            }

            var noSignos = /[,."'?!¡¿:;)(\[\]]/ig;
            var palabras = $("#"+idActividad+"__respuesta"+nPregunta).val().toLowerCase().replace(noSignos, "").replace(/[\n\t]/ig," ").split(" ");
            if($.trim($("#"+idActividad+"__respuesta"+nPregunta).val()).length==0){
            	// NO HA ESCRITO NADA
                alert("No se ha respondido la pregunta");
                $("#"+idActividad+"__respuesta"+nPregunta).focus();
                return;
            }
            var buenas = 0;
            $.each(palabras,function(i){
                if(palabras[i]!=""){
                    if(contienePalabra(palabras[i],prespuestas,correctas))
                        buenas++;
                }
            });

            buenas = 0;
            $.each(correctas,function(){
                buenas += this;
            });
            //alert("obtubiste: "+correctas+" total: "+buenas);

            // ---------- Obtengo el porcentaje obtenido de correctas --------------
            var porcentaje = 0;
            if(correctas.length>0)
                porcentaje = buenas*100/correctas.length;

            // ---------- Muestro la retroalimentacion textual  ---------
            if(datosAct.rtextual){//Si puede mostrar retroalimentacion textual
                var mensajes = obtenerMensaje(idActividad,nPregunta);
				//RUDY: Sgte linea comentada para evitar mostrar mnsj de retroalim en textarea
                muestraMesnaje($("#"+idActividad+"__retro"+nPregunta),porcentaje,mensajes);
            }

            var datos = idActividad+"__respuesta"+nPregunta+"="+$("#"+idActividad+"__respuesta"+nPregunta).val()
            if(guarda)
                guardarEjercicio(idActividad,nPregunta,"textarea",datos,porcentaje);

        }


        function contienePalabra(palabra, prespuestas,correctas){
            for(var i=0;i<prespuestas.length;i++){
                for(var j=0;j<prespuestas[i].length;j++){
                    if((" "+prespuestas[i][j].toLowerCase()+" ").indexOf(" "+palabra+" ")>=0){
                        correctas[i]=1;
                        return true;
                    }
                }
            }
            return false;
        }


        // --------- ENVIO Y RECEPCION DE DATOS CONTESTADOS -------------------

        var nerror = 0;
        var datosContestados = null;
        function verificarContestados(){
            try{
            jQuery.isFunction(wwwroot);
            }catch(e){
				alert("No esta definido wwwroot y no podras guardar.");
                return;
			}
            $.ajax({
                async:true,
                type: "POST",
                dataType: "json",
                contentType: "application/x-www-form-urlencoded",
                url:wwwroot()+"/mod/inea/automatizacion/proxy.php",
                data:"userid="+id_usuario+"&courseid="+id_curso+"&contestado=1",
                success:function(response){//Cuando recibo los datos.
                    datosContestados = response;
                    if(!response.error){
                        if(response.contestado){
                            $.each(response.datos,function(){
                                var ejercicio = this;
                                var datosAct = datosActividades[ejercicio.id_ejercicio];
                                $.each(ejercicio.respuestas,function(){
                                    for(var preg in this.datos){
                                        if(ejercicio.tipo=="checkbox"){
                                            $("#"+preg).attr("checked","checked");
                                        }else if(ejercicio.tipo=="radio"){
                                            $("input[name='"+preg+"']").eq(this.datos[preg]).attr("checked","checked")
                                        }else{
                                            $("#"+preg).val(this.datos[preg]);
                                        }

                                    }

                                    switch(ejercicio.tipo){
                                        case "textarea":
                                            evaluaTextarea(ejercicio.id_ejercicio+"__boton"+this.pregunta,false);
                                            break;
                                        case "select":
                                            evaluaSelect(ejercicio.id_ejercicio+"__boton"+this.pregunta,false);
                                            break;
                                        case "text":
                                            evaluaText(ejercicio.id_ejercicio+"__boton"+this.pregunta,false);
                                            break;
                                        case "radio":
                                            evaluaRadio(ejercicio.id_ejercicio+"__boton"+this.pregunta,false);
                                            break;
                                        case "checkbox":
                                            evaluaCheckbox(ejercicio.id_ejercicio+"__boton"+this.pregunta,false);
                                            break;
                                    }
                                });

                            });
                        }
                    }else{
                        alert(response.dataError);
                    }		//alert(datos);
                },
                timeout:20000,
                error:function(datos){
                    nerror++;
                    if(nerror<2)
                        verificarContestados();
                }
            });
        }

        function guardarEjercicio(id_ejercicio,pregunta,tipo,datos,retroalimentacion){
            //alert(id_ejercicio+" -- "+tipo+" -- "+datos+" -- "+retroalimentacion);
            //var datosx = $("#U1-T1-A1-E4").serialize();
            //alert(datosx);
            //return false;

            try{
            jQuery.isFunction(wwwroot);
            }catch(e){
                return;
            }

            var nerror = 0;
            $.ajax({
                async:true,
                type: "POST",
                dataType: "text",
                contentType: "application/x-www-form-urlencoded",
                url:wwwroot()+"/mod/inea/automatizacion/proxy.php?userid="+id_usuario+"&courseid="+id_curso+"&id_ejercicio="+id_ejercicio+"&pregunta="+pregunta+"&tipo="+tipo+"&retroalimentacion="+retroalimentacion,
                data:datos,
                success:function(datos){//Cuando recibo los datos.
                    //alert(datos);
                },
                timeout:20000,
                error:function(datos){
                    nerror++;
                    if(nerror<2)
                        verificarContestados();
                }
            });
        }

        // --------------------------------------------------------------------

        
        //var mensaje = $.api.transformar(mensaje);
        //alert(opciones.inicio_str + mensaje + opciones.final_str);
    }

    $.api.preloadImages = function()
    {
        for(var i = 0; i<arguments.length; i++)
        {
            $("<img>").attr("src", arguments[i]);
        }
    }

    $.api.opciones = undefined

    $.api.datosActividades = undefined;

    $.api.op_default = {
        ruta_imagen_revisar : "images/revisar.gif",
        ruta_imagen_retro_bien : "",
        ruta_imagen_retro_mal : "",
        ruta_imagen_bien : "images/acierto.gif",
        ruta_imagen_mal: "images/error.gif"
    }
    $.api.botones = Array();

    $.api.heightAnterior = 0;
    $.api.revisaTamano = function(){
        var dif = $.api.heightAnterior - $(document).height();
        if($.api.heightAnterior != $(document).height() && (dif<-10 || dif>10) ){
            $(".visual").each(function(){
                var pregunta = this.id.replace("__visual","__respuesta");
                if($("#"+pregunta).length>0){
                var offsetin = $("#"+pregunta).offset();
                //offsetin.left = offsetin.left+10;
                $(this).offset({"top": offsetin.top,"left":$(this).offset().left});
                }
            });
            $.api.heightAnterior = $(document).height();
            
        }
         setTimeout($.api.revisaTamano,500);
    }

    $.api.style = {};

    $.api.style.actividad = {};
    $.api.style.instrucciones = {};
    $.api.style.pregunta = {};
    $.api.style.respuesta = {};
    $.api.style.bien = {"display":"none","width": "450px", "border": "1px dotted #C46AA9", "background-color":"#D1E1EE", "padding": "5px", "margin-left": "50px"};
    $.api.style.mal =  {"display":"none","width": "450px", "border": "1px dotted #D1E1EE", "background-color":"#E1B4D3", "padding": "5px", "margin-left": "50px"};
    

})(jQuery);
